Change 499 on 2001/05/31 by klaren@klaren.hawking.dev

   - Ported action.g fixes from C++ to Java action.g. Warnings and errors
     in actions are now correctly reported in java mode as well.
   - Ported $lookaheadSet functionality to java mode.
   - Moved processActionForTreeSpecifiers from CodeGenerator.java to
     JavaCodeGenerator.java and made it abstract. Added setFileName call
     to it.
   - Added a lot of getLine's to calls of processActionForTreeSpecifiers in
     JavaCodegen.
   - Moved a number one liner methods to the header file for better inlining.
   - Added clear methods to the Queue type objects (java/C++).
   - Added reset methods to the Input/TokenBuffer objects (java/C++).
   - Added reset methods to the SharedInputState objects (java/C++).
   - Added to the C++ LexerSharedInputState an initialize function that
     reinitializes the thing with a new stream.
   - Added docu.

   - Bugfix: Initialized attribute filename a little bit earlier so error
	  message shows the filename in stead of 'null'.

Change 495 on 2001/05/31 by klaren@klaren.hawking.dev

   Added -h/-help/--help options. Adapted the year range in the copyright in
   the help message.

Change 494 on 2001/05/29 by klaren@klaren.hawking.dev

   Changed order of equals test a bit to be more efficient.

Change 493 on 2001/05/29 by klaren@klaren.hawking.dev

   Moved some methods a bit around to get better inlining.

Change 492 on 2001/05/22 by klaren@klaren.hawking.dev

   Dug up a mail from Bill Zheng about doxygen. Fixed a few things as a result.

Change 491 on 2001/05/22 by klaren@klaren.hawking.dev

   More tweaks for the ditching of the tokenNames vector. GNU C++ had some
   trouble with the previous incarnation.

Change 490 on 2001/05/21 by klaren@klaren.hawking.dev

   Changed all remaining "antlr/xxx.hpp" includes to <antlr/xxx.hpp> ones
   in the header files.

Change 489 on 2001/05/18 by klaren@klaren.hawking.dev

   Missed a few tracer class changes in this one. Also some missing
   virtuals fixed.

Change 488 on 2001/05/18 by klaren@klaren.hawking.dev

   Removed /** from license comments, they brought doxygen of track.
   Replaced ANTLR_BEGIN/END_NAMESPACE defines with a
   ANTLR_CXX_SUPPORTS_NAMESPACE macro, again for doxygen. Here and there some
   reformatting and reordering.

Change 487 on 2001/05/18 by klaren@klaren.hawking.dev

   Optimizations in Tracer classes (dumped string's). Removed setTokenNames
   from the support library. Switched tokenNames to use a char* array.
   Generate NUM_TOKENS attribute in parsers. Added getNumTokens methods to
   parsers. Changes in MismatchedTokenException to reflect the previous.

Change 486 on 2001/05/18 by klaren@klaren.hawking.dev

   Allow whitespace between $setxxx and following '('.

Change 485 on 2001/05/14 by klaren@klaren.hawking.dev

   And now really fix giving errors... stupid java *snicker*

Change 484 on 2001/05/14 by klaren@klaren.hawking.dev

   Allow whitespace between $setxxx and following '('.

Change 483 on 2001/05/14 by klaren@klaren.hawking.dev

   Give errors when target file/directory not writeable.

Change 482 on 2001/05/11 by klaren@klaren.hawking.dev

   Added config file for doxygen.

Change 480 on 2001/05/11 by klaren@klaren.hawking.dev

   Tagged a bug in the code. (heteroast trouble)

Change 479 on 2001/05/11 by klaren@klaren.hawking.dev

   Added Ernest Pasour's $lookaheadSet feature to the C++ codegen. (This
   needs to be ported to Java mode). Also cleaned up action.g's error
   reporting this should also be ported to java mode.

Change 476 on 2001/05/11 by klaren@klaren.hawking.dev

   More fixes for XML I/O. It's a bit tidier now. Some too advanced things
   removed (ios_base::failure). Embedding custom XML elements in the stream
   should be possible now.

Change 475 on 2001/05/08 by parrt@parrt.foggy

   made default charbuffer bigger per token.

Change 471 on 2001/04/26 by klaren@klaren.hawking.dev

   Bugfix: in case of a certain order of header actions (pre_include_xx etc.)
   one header action might overwrite another. Probably only affects C++.

Change 468 on 2001/03/22 by klaren@klaren.hawking.dev

   A few extra ANTLR_API's to make antlr.dll work from other dll's. Thanks
   to Ernest Passour.

Change 466 on 2001/03/15 by klaren@klaren.hawking.dev

   Fix from Emir Uner for KAI C++ cast string literal to 'const
   char*' for make_pair.

Change 465 on 2001/03/08 by klaren@klaren.hawking.dev

   Fix for bugreport from Emir Uner, static member const char *
   initializations are not standard compliant.

Change 464 on 2001/03/05 by klaren@klaren.hawking.dev

   Changes for XML input and output. Restructuring of ASTFactory and some
   fixes for heterogeneous AST's.

Change 463 on 2001/02/05 by klaren@klaren.hawking.dev

   Improved exception handling in trace routines of parser. Patch submitted
   by John Fremlin. Tracer class now catch exceptions from lexer. Fixed
   forgotten message in BitSet.cpp.

Change 462 on 2001/02/05 by klaren@klaren.hawking.dev

   Improved errormessage. Now says unexpected end of file and stuff like that.

Change 461 on 2001/01/31 by klaren@klaren.hawking.dev

   Changed the position of the init actions for (..)* (..)+ to just inside
   the loop handling the closure. This way we can check EOF conditions in the
   init action for each loop invocation.

Change 460 on 2001/01/31 by klaren@klaren.hawking.dev

   Fixed typo in error message.

Change 458 on 2001/01/17 by klaren@klaren.hawking.dev

   Removed dos newlines.

Change 457 on 2001/01/15 by klaren@klaren.hawking.dev

   Removed the superfluous '// line xxx' comments in genHashLines=false case.

Change 454 on 2001/01/11 by klaren@klaren.hawking.dev

   Updated the changelog and fixed buglet in changelog script.

Change 453 on 2001/01/11 by klaren@klaren.hawking.dev

   Tweaked the make_change_log script to include both my dev depot as well
   as the main branch.

Change 452 on 2001/01/11 by klaren@klaren.hawking.dev

   Changes to let ANTLR only overwrite a file if it really changes. (Mainly
   for C++ mode). With supporting changes in mkxxxjar batch files.

Change 451 on 2001/01/11 by klaren@klaren.hawking.dev

   Changed the charName in C++ mode and NoViableAltForCharException in java
   mode so that only printable characters are printed and non printable ones
   get 'hexdumped'.

Change 450 on 2001/01/10 by klaren@klaren.hawking.dev

   Fixed some typo's in javadoc comments.

Change 449 on 2001/01/08 by klaren@klaren.hawking.dev

   Removed StdAfx.h from the .dsp file.

Change 448 on 2001/01/08 by klaren@klaren.hawking.dev

   Added implementations for getLAChars and getMarkedChars.

Change 447 on 2001/01/05 by klaren@klaren.hawking.dev

   Small fix to the genBitSets method of CppCodeGenerator now the generated
   sets are also dumped for lexers.

Change 446 on 2000/12/18 by klaren@klaren.hawking.dev

   Changes for MSCV DLL building. Now also includes dsp/dsw files.
   Contributed by Stephen Naughton.

Change 444 on 2000/12/12 by klaren@klaren.hawking.dev

   Added <string> include. (Needed for new gcc version 2.97)

Change 441 on 2000/12/05 by klaren@klaren.hawking.dev

   Fixed problems with buggy tolower (truncating -1 (EOF) to 0xff)
   functions together with STLport/HPUX also reverted fix 422 since this
   one also catches that.

Change 440 on 2000/11/30 by klaren@klaren.hawking.dev

   Fixed typo in code generated for $setText.

Change 439 on 2000/11/22 by klaren@klaren.hawking.dev

   Few minor tweaks. And removed my name from the generated author section
   a bit too much copy'n'paste.

Change 438 on 2000/11/20 by klaren@klaren.hawking.dev

   Fixed bug with C/C++ preprocessor constructs (#if's etc). Also changed
   code generated for $setText to be surrounded by '{}'.

Change 437 on 2000/11/20 by klaren@klaren.hawking.dev

   SGI Irix 6.5.10 MIPSPro compiler support contributed by Anna Winkler.

Change 436 on 2000/11/20 by klaren@klaren.hawking.dev

   Virtualized a most methods of Parser and LLkParser (as requested by
   Alexander Lenski)

Change 434 on 2000/11/09 by klaren@klaren.hawking.dev

   First stab at a docbook codegenerator. It now produces something that get's
   parsed by jade and gives pretty ok HTML output.

Change 433 on 2000/11/08 by klaren@klaren.hawking.dev

   Cleaned up some superfluous methods.

Change 432 on 2000/11/08 by klaren@klaren.hawking.dev

   Cleaned up generated HTML added quoting for special entities (probably
   still missed some). Removed printing of parameters, returns, syntactic
   and semantic actions since these obscure the output. It's now HTML 4.01
   Transitional compliant it seems.

Change 427 on 2000/10/23 by klaren@klaren.hawking.dev

   Virtualized destructors in xxSharedInputState. This to support
   overloading. By request of Alexander Lenski.

Change 426 on 2000/10/19 by klaren@klaren.hawking.dev

   Incorporated bugfix suggested by Joe Comuzzi. Fixes ommission of
   semantic predicates in the big unicode case.

Change 425 on 2000/10/19 by klaren@klaren.hawking.dev

   Michael Schmitt's changes for a better exception hierarchy.

Change 424 on 2000/10/19 by klaren@klaren.hawking.dev

   Cleaned up generated code a bit. Removed excess constructors etc.

Change 422 on 2000/10/03 by klaren@klaren.hawking.dev

   Fix for VC++ 6.0 bug with tolower and setlocale

Change 421 on 2000/10/03 by klaren@klaren.hawking.dev

   Integrate 2.7.1 main line into development version.

Change 412 on 2000/10/01 by parrt@parrt.foggy

   changes to prevent Tool from runtime jar

Change 410 on 2000/10/01 by parrt@parrt.foggy

   hetero tree labels are of the specified type if any instead of AST

Change 409 on 2000/10/01 by parrt@parrt.foggy

   updated output of .g files

Change 407 on 2000/10/01 by parrt@parrt.foggy

   added column tracking example, updated commontoken to print col.

Change 405 on 2000/09/27 by parrt@parrt.foggy

   changed type

Change 401 on 2000/09/27 by klaren@klaren.hawking.main

   ChangeLog updated. + tweak to script.

Change 400 on 2000/09/27 by klaren@klaren.hawking.main

   Made little TCL script to pretty print a ChangeLog with C++ stuff.

Change 399 on 2000/09/27 by klaren@klaren.hawking.main

   Fixed generating too many ASTNULL checks in wrong places.

Change 397 on 2000/09/27 by klaren@klaren.hawking.main

   Some *UGLY* fixes for the last typecasting problems in Cpp codegen. It
   now works. In 2.7.2 or later I'll fix this in a nice way.

Change 394 on 2000/09/26 by klaren@klaren.hawking.main

   Prefixed Unicode optimization checks with a ASTNULL check.

Change 393 on 2000/09/25 by klaren@klaren.hawking.main

   Bumped up the version no from 2.7.1a4 to 2.7.1.

Change 381 on 2000/09/24 by parrt@parrt.foggy

   updated to use addElement

Change 380 on 2000/09/24 by parrt@parrt.foggy

   integrating ric's stuff into main

Change 378 on 2000/09/23 by klaren@klaren.hawking.dev

   Forgot another ANTLR_USE_NAMESPACE macro.

Change 377 on 2000/09/22 by klaren@klaren.hawking.dev

   More todo's collected from my mailbox..

Change 372 on 2000/09/22 by klaren@klaren.hawking.dev

   Updated.

Change 371 on 2000/09/22 by klaren@klaren.hawking.dev

   More TODO's...

Change 370 on 2000/09/22 by klaren@klaren.hawking.dev

   Added nested namespace support submitted by David Wagner.

Change 369 on 2000/09/22 by klaren@klaren.hawking.dev

   Bug fix for #ast_in and #( #ast_in ) differences. Split of
   actions/java/action.g into a java and cpp part. C++-isms removed from java
   part. Added support in C++ part for some_method(static_cast<sumthin>(#ast)).

Change 367 on 2000/09/22 by klaren@klaren.hawking.dev

   Port of Unicode optimizations from java. Fixes for custom AST usage.

Change 366 on 2000/09/22 by klaren@klaren.hawking.dev

   Implemented missing initializes to CAWHT for Sun CC 6.0 and fixed throw
   out_of_range for STL_PORT in BitSet.cpp.

Change 363 on 2000/09/13 by parrt@parrt.foggy

   set initial column to 1 instead of 0

Change 362 on 2000/09/13 by klaren@klaren.hawking.dev

   Some bugfixes for getASTCreateString( ... ) hopefully all mismatches between
   astFactory.create and it's parameters are fixed. (Maybe even a speed
   improvement)

Change 360 on 2000/09/13 by klaren@klaren.hawking.dev

   Borland C++ builder 4.0 project files for antlr.lib donated by Ross Bencina

Change 358 on 2000/09/11 by klaren@klaren.hawking.dev

   Removed a superfluous typename (caused problem with Irix Mips compiler)

Change 349 on 2000/09/08 by klaren@klaren.hawking.dev

   More configure tweaks. Some libtool enhancements added.

Change 348 on 2000/09/07 by klaren@klaren.hawking.main

   Small improvement in constructor of CommonAST.

Change 346 on 2000/09/07 by klaren@klaren.hawking.dev

   Miniscule fix for Borland C++Builder 4.0/C++ 5.4. (extra parens)

Change 344 on 2000/09/06 by klaren@klaren.hawking.main

   Fixed missing namespace in generated TreeParsers as reported by Ross
   Bencina.

Change 343 on 2000/09/06 by klaren@klaren.hawking.dev

   Fixed namespace mishap with generated TreeParser constructors as reported
   by Ross Bencina.

Change 342 on 2000/09/06 by klaren@klaren.hawking.dev

   Some small optimizations. And a maybe fix for Borland compiler warning.

Change 341 on 2000/09/06 by klaren@klaren.hawking.main

   Miniscule fix for Borland C++Builder 4.0/C++ 5.4. (extra parens)

Change 340 on 2000/09/05 by mika@y0

   Sather code generation/runtime catching up with Java bug fixes/enhancements

Change 338 on 2000/09/03 by parrt@parrt.foggy

   cleaned up formatting

Change 336 on 2000/09/03 by parrt@parrt.foggy

   optimized out the large unicode sets from switches.

Change 335 on 2000/09/03 by parrt@parrt.foggy

   up'd version to 2.7.1

Change 334 on 2000/09/03 by parrt@parrt.foggy

   added throws option for rules

Change 330 on 2000/08/30 by klaren@klaren.hawking.dev

   Small 'fix' to RecognitionException getFileLineString.

Change 325 on 2000/08/29 by klaren@klaren.hawking.dev

   Shut a few compiler warnings up.

Change 323 on 2000/08/24 by klaren@klaren.hawking.dev

   importVocab statements now cause antlr to look in $PWD first for the
   imported vocabulary files, and if that fails, to check in the directory
   specified by the '-o <output_dir>' command-line argument

Change 322 on 2000/08/24 by klaren@klaren.hawking.dev

   More typecasts for nullAST's. (Should be the last)

Change 319 on 2000/08/23 by klaren@klaren.hawking.dev

   Michael Schmitt found a missing static_cast in the generated C++ code.

Change 318 on 2000/08/22 by klaren@klaren.hawking.dev

   So many things to do... <sigh>

Change 317 on 2000/08/22 by klaren@klaren.hawking.main

   Updated changelog for a5 (or was it 2.7.1) release..

Change 316 on 2000/08/22 by klaren@klaren.hawking.main

   All kinds of small Makefile/configure tweaks. All gcc-isms should be
   gone now.

Change 315 on 2000/08/21 by bob@bob.melvin

   importVocab statements now cause antlr to look in $PWD first
   for the imported vocabulary files, and if that fails, to
   check in the directory specified by the '-o <output_dir>'
   command-line argument

Change 310 on 2000/08/16 by klaren@klaren.hawking.dev

   Fixed a bug concerning one of the nullAST initialization strings being unset.

Change 309 on 2000/08/15 by klaren@klaren.hawking.main

   Integrate bugfixes from klaren.dev to MismatchedChar/TokenException.

Change 308 on 2000/08/15 by klaren@klaren.hawking.dev

   Fixes for some cut'n'paste'o's in MismatchedToken/CharException (error
   messages are ok again)

Change 307 on 2000/08/15 by klaren@klaren.hawking.dev

   Added todo list.

Change 306 on 2000/08/14 by klaren@klaren.hawking.dev

   Configure fixes and a small cleanup.

Change 305 on 2000/08/14 by klaren@klaren.hawking.dev

   Got rid of the last member template. At the expense of some casts.

Change 304 on 2000/08/11 by klaren@klaren.hawking.dev

   Last changes for ASTLabelType support. It seems to work now.

Change 303 on 2000/08/10 by klaren@klaren.kronecker.dev

   Changes for better support of ASTLabelType in C++ grammars.

Change 302 on 2000/08/08 by klaren@klaren.kronecker.dev

   Sync with main tree.

Change 301 on 2000/08/08 by klaren@klaren.kronecker.main

   Fix for the $setText bug in C++ code generation.
   More C++ fixes to action.g. Allow '->' in $setText arguments and some other places.

Change 298 on 2000/08/08 by klaren@klaren.kronecker.dev

   Integrate main branch with playground.

Change 297 on 2000/08/07 by klaren@klaren.kronecker.main

   Fixes for namespace/namespaceAntlr/namespaceStd/genHashLines options.

Change 296 on 2000/08/07 by klaren@klaren.kronecker.main

   Virtualized all functions that someone should want to override. Probably
   necessary for heteroAST stuff.

Change 291 on 2000/08/07 by klaren@klaren.kronecker.main

   Some tweaks to configure.in and Makefile.am's. Fix for CXXFLAGS being
   set incorrectly when not using gcc.

Change 290 on 2000/08/05 by klaren@klaren.kronecker.main

   Updated prototype of toLower to definition in cpp file. It seems I
   messed them up a while back.

Change 289 on 2000/08/05 by klaren@klaren.kronecker.main

   Added namespace macro to out_of_range exception.

Change 288 on 2000/07/28 by parrt@parrt.foggy

   re-added toLower return type fix

Change 285 on 2000/07/19 by klaren@klaren.kronecker.main

   Fixed thinko.

Change 284 on 2000/07/19 by klaren@klaren.kronecker.main

   Dumped output of p4 changes -l into it...

Change 283 on 2000/07/19 by klaren@klaren.kronecker.main

   Fix for bug found by Michael Ebner. Bitset size was not increased in add method.

Change 280 on 2000/07/19 by klaren@klaren.kronecker.main

   Made namespaceAntlr, namespaceStd and genHashlines options file-level
   options. Removed nameSpace member from Tool class all is now handled in
   CppCodegenerator.java.

Change 279 on 2000/07/18 by klaren@klaren.kronecker.main

   Added -diagnostic and -glib options to the usage message.

Change 278 on 2000/07/18 by klaren@klaren.kronecker.main

   Java changes for indented traceIn/Out stuff.

Change 276 on 2000/07/18 by klaren@klaren.kronecker.main

   C++ Changes for the indented traceXXXX output as invented by Monty Zukowski

Change 275 on 2000/07/18 by klaren@klaren.kronecker.main

   Added missing initializer in generated code for TreeParser

Change 272 on 2000/07/17 by klaren@klaren.kronecker.main

   Another workspace for MSVC6 has support for dll's (for version 2.6.1).

Change 271 on 2000/07/17 by klaren@klaren.kronecker.main

   New autoconf/automake stuff for the C++ support library.

Change 270 on 2000/07/17 by klaren@klaren.kronecker.main

   Fixed error within the NO_STATIC_CONSTS #ifdef

Change 269 on 2000/07/17 by klaren@klaren.kronecker.main

   Move C++ files to lib/cpp/src as first step for autoconf setup

Change 268 on 2000/07/17 by klaren@klaren.kronecker.main

   Add contrib dir and Microsoft Visual C++ 6.0 projects supplied by John Millaway

Change 262 on 2000/07/16 by parrt@parrt.foggy

   changed version to 2.7.1a4

Change 261 on 2000/07/16 by parrt@parrt.foggy

   added constructors for this class

Change 260 on 2000/07/14 by klaren@klaren.kronecker.main

   Fixed crashbugs/typos in constructors of Mismatched[Token|Char]Exception

Change 259 on 2000/07/13 by parrt@parrt.foggy

   cutting ric's branch

Change 258 on 2000/07/10 by parrt@parrt.foggy

   fixes per klaren

Change 255 on 2000/07/09 by parrt@parrt.foggy

   removed magelang from tag line

Change 252 on 2000/07/09 by parrt@parrt.foggy

   reformatted

Change 251 on 2000/07/04 by mika@y0

   Reflecting change to the Java action lexer in the Sather action lexer

Change 249 on 2000/07/04 by parrt@parrt.foggy

   changed version number

Change 248 on 2000/07/04 by parrt@parrt.foggy

   Ric Klaren's changes to C++ lib

Change 247 on 2000/07/04 by parrt@parrt.foggy

   Ric Klaren's changes for namespaces

Change 246 on 2000/06/16 by mika@y0

   reflecting changes antlr/CodeGenerator.java #3 -> #4

Change 245 on 2000/06/16 by mika@y0

   reflecting changes in antlr/actions/java/action.g #3 -> #4

Change 242 on 2000/06/06 by parrt@parrt.foggy

   fixed my new method addition to handle empty input case correctly

Change 241 on 2000/06/06 by parrt@parrt.foggy

   allows whitespace now after ( in $setType.

Change 240 on 2000/06/03 by parrt@parrt.foggy

   fixed a bug where duplicate grammars caused an exception

Change 239 on 2000/06/03 by parrt@parrt.foggy

   adjusted so it works; header actions got converted to Token objects from Strings; lots of cast problems and then null ptr exceptions.

Change 238 on 2000/06/03 by parrt@parrt.foggy

   made it ignore zero-length strings for processActionForTreeSpecifiers

Change 237 on 2000/06/03 by parrt@parrt.foggy

   had to run ANTLR on antlr.g to make it compile.

Change 236 on 2000/06/03 by parrt@parrt.foggy

   changed refs to headerActions to imply Token not String.

Change 235 on 2000/05/31 by pete@pete.linux

   More changes to support #line generation in C++ (from Ric Klaren)

Change 233 on 2000/05/30 by mika@y0

   Bug fixes from Gilbert Roulot

Change 232 on 2000/05/29 by parrt@parrt.foggy

   improved diagnostic DEBUG_ANALYZER output a lot and fixed a nasty FOLLOW cycle computation bug.  I was being too aggressive with my locking; i locked block end nodes even when not computing FIRST(block start).

Change 231 on 2000/05/29 by parrt@parrt.foggy

   added code to print out FOLLOW set for rule at end

Change 230 on 2000/05/29 by parrt@parrt.foggy

   added code you can uncomment to print out grammar after code gen

Change 229 on 2000/05/29 by parrt@parrt.foggy

   changed version to 2.7.1a2

Change 228 on 2000/05/29 by parrt@parrt.foggy

   added toString method to print out rules

Change 227 on 2000/05/29 by parrt@parrt.foggy

   added code to dump lookahead sets for each alt in toString()

Change 220 on 2000/05/29 by parrt@parrt.foggy

   changed char to int for toLower

Change 219 on 2000/05/28 by pete@pete.linux

   Mirroring Java changes

Change 218 on 2000/05/28 by pete@pete.linux

   Cleaned up the #line generator a little.

Change 217 on 2000/05/27 by parrt@parrt.foggy

   bug fix: wasn't providing always 4 digits for escapeChar.

Change 216 on 2000/05/27 by parrt@parrt.foggy

   added checking for unterminated rules

Change 215 on 2000/05/27 by parrt@parrt.foggy

   added column tracking support; tabs are counted as 1

Change 214 on 2000/05/27 by parrt@parrt.foggy

   allow comments after tokens/options etc...

Change 213 on 2000/05/27 by parrt@parrt.foggy

   setInputState was actually getInputState :(

Change 212 on 2000/05/27 by parrt@parrt.foggy

   updated to handle } in tokens{}

Change 211 on 2000/05/27 by parrt@parrt.foggy

   had same bug as JavaCodeGenerator related to ~(A|B)

Change 208 on 2000/05/27 by parrt@parrt.foggy

   updated version

Change 205 on 2000/05/24 by pete@pete.linux

   Add support for Metrowerks Codewarrior

Change 203 on 2000/05/22 by pete@pete.linux

   Fix for multithreading from Jan Mikkelsen

Change 202 on 2000/05/21 by pete@pete.linux

   Merged in some fixes from Ric Klaren for tracing TreeParsers, cleaner namespace
   code, and #line generation.

Change 201 on 2000/05/21 by pete@pete.linux

   Added destructors with empty throw specs, as suggested by Dan Field.

Change 200 on 2000/05/21 by pete@pete.linux

   Various performance improvements, mostly from Eric Dumas.

Change 183 on 2000/02/08 by pete@pete.linux

   Added support for Sun CC 5.0 (from Michael Schmitt)

Change 182 on 2000/02/08 by pete@pete.linux

   Fix a couple of minor problems with C++ generation (noted by Michael Schmitt)

Change 162 on 2000/01/20 by mika@y0

   heterogeneous AST change.  not sure if correct.

Change 153 on 2000/01/19 by parrt@parrt.foggy

   forgot to propogate b1 changes to mkjar etc..

Change 151 on 2000/01/19 by parrt@parrt.foggy

   pushing changes back into main/main from fixed tree stuff

Change 142 on 2000/01/19 by parrt@parrt.foggy

   propogating mika's changes forward

Change 132 on 2000/01/18 by parrt@parrt.foggy

   setting type to ktext for everything

Change 131 on 2000/01/18 by parrt@parrt.foggy

   from dev back to main

Change 1 on 1999/12/13 by parrt@parrt.foggy

   adding 2.6.0 from antlr site as initial main line

